#!/usr/bin/env python3
import sys

def peano(max_len):
    line = sys.stdin.readline()
    assert line[-1] == '\n'
    assert len(line) <= max_len+1 # +1 for newline
    i = 0
    j = len(line)-2
    while i < j:
        assert line[i:i+2] == 'S(' and line[j] == ')'
        i += 2
        j -= 1
    assert j == i and line[i] == '0', (i, j, line[i])

peano(1000)
peano(1000)
assert sys.stdin.readline() == ''
sys.exit(42)
